//Node ::= e ElemName "{" Node* "}"
//       | a AttrName "{" Node* "}"
//       | E  VarName "{" Node* "}"
//       | A  VarName "{" Node* "}"
//       | S   String
//       | x  VarName
//       | g VarName+ "{" (Int Node*)+ "}"
//       | v VarName+ "{" (Int Node*)+ "}"

struct Node_t { virtual ~Node_t(){} };
typedef shared_ptr<Node_t> Node;
struct Elem    : Node_t {string D; vector<Node> C; Elem(const string& d, const vector<Node>& c):D(d),C(c){}};
struct Attr    : Node_t {string D; vector<Node> C; Attr(const string& d, const vector<Node>& c):D(d),C(c){}};
struct DynElem : Node_t {string D; vector<Node> C; DynElem(const string& d, const vector<Node>& c):D(d),C(c){}};
struct DynAttr : Node_t {string D; vector<Node> C; DynAttr(const string& d, const vector<Node>& c):D(d),C(c){}};
struct Pcdata  : Node_t {string D; Pcdata(const string& d):D(d){}};
struct Var     : Node_t {string D; Var(const string& d):D(d){}};
struct GVUnit_t  { Automaton A; vector<Node> C; GVUnit_t(const char* a, const vector<Node>& c):A(a),C(c){}};
typedef shared_ptr<GVUnit_t> GVUnit;
struct Gather  : Node_t {string V; vector<GVUnit> U; Gather(const string& v,const vector<GVUnit>& u):V(v),U(u){}};
struct Visit   : Node_t {string V; string R; vector<GVUnit> U; Visit(const string& v,const string& r,const vector<GVUnit>& u):V(v),R(r),U(u){}};

vector<Node> parse_template( const char* dir );
