#include "common.h"

extern "C"
{
//#include <libparsifal/parsifal.h>
#include "parsifal/parsifal.h"

	int start_e(void* user, const XMLCH*, const XMLCH*, const XMLCH* qname, LPXMLVECTOR att)
	{
		SAXHandler* d = (SAXHandler*)user;
		if(!d->buf.empty()) d->text(d->buf), d->buf.clear();

		vector<SAXAttr> v;
		for(int i=0; i<att->length; ++i) {
			XMLRUNTIMEATT* a = (XMLRUNTIMEATT*) XMLVector_Get(att, i);
			v.push_back( SAXAttr((const char*)a->qname,(const char*)a->value) );
		}
		return d->start_e( (const char*)qname, v ) ? XML_OK : XML_ABORT;
	}

	int end_e(void* user, const XMLCH*, const XMLCH*, const XMLCH*)
	{
		SAXHandler* d = (SAXHandler*)user;
		if(!d->buf.empty()) d->text(d->buf), d->buf.clear();
		return d->end_e() ? XML_OK : XML_ABORT;
	}

	int chars(void* user, const XMLCH* buf, int siz)
	{
		SAXHandler* d = (SAXHandler*)user;
		d->buf.insert(d->buf.end(), (const char*)buf, (const char*)buf+siz);
		return XML_OK;
	}

	int cstream(unsigned char *buf, int cBytes, int *cBytesActual, void *inputData)
	{
		*cBytesActual = fread(buf, 1, cBytes, (FILE*)inputData);	
		return (*cBytesActual < cBytes);
	}
}

bool parse( const char* filename, SAXHandler* han )
{
	LPXMLPARSER px;
	XMLParser_Create(&px);
	px->UserData = han;
	px->startElementHandler = &start_e;
	px->endElementHandler   = &end_e;
	px->charactersHandler   = &chars;
	_XMLParser_SetFlag(px, XMLFLAG_PRESERVE_GENERAL_ENTITIES, true);

	FILE* fp = fopen(filename, "rb");
	if( !fp )
		return false;
	XMLParser_Parse(px, &cstream, fp, NULL);
	fclose(fp);
	XMLParser_Free(px);
	return true;
}
