#include "common.h"
#include <expat.h>

extern "C"
{

	void start_e(void* user, const XML_Char* qname, const XML_Char**atts)
	{
		SAXHandler* d = (SAXHandler*)user;
		if(!d->buf.empty()) d->text(d->buf), d->buf.clear();

		vector<SAXAttr> v;
		for(int i=0; atts[i]; i+=2)
			v.push_back( SAXAttr((const char*)atts[i],(const char*)atts[i+1]) );

		d->start_e( (const char*)qname, v );
	}

	void end_e(void* user, const XML_Char* qname)
	{
		SAXHandler* d = (SAXHandler*)user;
		if(!d->buf.empty()) d->text(d->buf), d->buf.clear();
		d->end_e();
	}

	void chars(void* user, const XML_Char* buf, int siz)
	{
		SAXHandler* d = (SAXHandler*)user;
		d->buf.insert(d->buf.end(), (const char*)buf, (const char*)buf+siz);
	}
}

bool parse( const char* filename, SAXHandler* han )
{
	XML_Parser px = XML_ParserCreate("UTF-8");
	XML_SetUserData(px, han);
	XML_SetElementHandler(px, &start_e, &end_e);
	XML_SetCharacterDataHandler(px, &chars);
//	_XMLParser_SetFlag(px, XMLFLAG_PRESERVE_GENERAL_ENTITIES, true);

	FILE* fp = fopen(filename, "rb");
	if( !fp )
		return false;
	fseek(fp,0,SEEK_END);
	size_t siz = ftell(fp);
	fseek(fp,0,SEEK_SET);
	void* buf = XML_GetBuffer(px, siz);
	fread(buf, 1, siz, fp);
	fclose(fp);

	XML_ParseBuffer(px, siz, 1);
	XML_ParserFree(px);
	return true;
}
